Skip to content

Custom Storage

The Custom Storage service collection provides operations for managing custom object storage within the CrowdStrike platform. List, describe, search, get, upload, and delete objects within named collections. Support includes versioned collections with schema management and metadata retrieval.

LanguageLast Update
Pythonv1.4.9
PowerShellv2.2.9
Gov0.20.0
TypeScriptv0.6.0
Rustv0.7.0
Rubyv1.2.0
OperationDescription
ListCollections
list_collections
List available collection names in alphabetical order.
DescribeCollections
describe_collections
Fetch metadata about one or more existing collections.
DescribeCollection
describe_collection
Fetch metadata about an existing collection.
ListObjects
list
List the object keys in the specified collection in alphabetical order.
SearchObjects
search
Search for objects that match the specified filter criteria (returns metadata, not actual objects).
GetObject
get
Get the bytes for the specified object.
PutObject
upload
Put the specified new object at the given key or overwrite an existing object at the given key.
DeleteObject
delete
Delete the specified object.
GetObjectMetadata
metadata
Get the metadata for the specified object.
ListSchemas
list_schemas
Get the list of schemas for the requested collection in reverse version order (latest first).
GetSchema
get_schema
Get the bytes of the specified schema of the requested collection.
GetSchemaMetadata
schema_metadata
Get the metadata for the specified schema of the requested collection.
ListObjectsByVersion
list_by_version
List the object keys in the specified collection in alphabetical order.
SearchObjectsByVersion
search_by_version
Search for objects that match the specified filter criteria (returns metadata, not actual objects).
GetVersionedObject
get_version
Get the bytes for the specified object.
PutObjectByVersion
upload_version
Put the specified new object at the given key or overwrite an existing object at the given key.
DeleteVersionedObject
delete_version
Delete the specified versioned object.
GetVersionedObjectMetadata
version_metadata
Get the metadata for the specified object.

List available collection names in alphabetical order.

GET /customobjects/v1/collections
Scope Custom Storage: READ Consumes · Produces application/json
PEP 8 list_collections
NameTypeData typeDescription
endquerystringThe end key to end listing to.
limitqueryintegerThe limit of results to return.
parametersquerydictionaryFull query string parameters payload in JSON format.
startquerystringThe start key to start listing from.
from falconpy import CustomStorage
falcon = CustomStorage(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.list_collections(end=["string"],
limit=integer,
start=["string"])
print(response)

Fetch metadata about one or more existing collections.

PUT /customobjects/v1/collections
Scope Custom Storage: READ Consumes · Produces application/octet-stream application/json
PEP 8 describe_collections
NameTypeData typeDescription
namesqueryarray (string)A set of collection names.
parametersquerydictionaryFull query string parameters payload in JSON format.
from falconpy import CustomStorage
falcon = CustomStorage(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.describe_collections(names=id_list)
print(response)

Fetch metadata about an existing collection.

GET /customobjects/v1/collections/{collection_name}
Scope Custom Storage: READ Consumes · Produces application/json
PEP 8 describe_collection
NameTypeData typeDescription
collection_namepathstringThe name of the collection
from falconpy import CustomStorage
falcon = CustomStorage(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.describe_collection(collection_name="string")
print(response)

List the object keys in the specified collection in alphabetical order

GET /customobjects/v1/collections/{collection_name}/objects
Scope Custom Storage: READ Consumes · Produces application/json
PEP 8 list
NameTypeData typeDescription
collection_namepathstringThe name of the collection
endquerystringThe end key to end listing to
limitqueryintegerThe limit of results to return
parametersquerydictionaryFull query string parameters payload in JSON format.
startquerystringThe start key to start listing from
from falconpy import CustomStorage
falcon = CustomStorage(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.list(collection_name="string",
end="string",
limit=integer,
start="string")
print(response)

Search for objects that match the specified filter criteria (returns metadata, not actual objects)

POST /customobjects/v1/collections/{collection_name}/objects
Scope Custom Storage: READ Consumes · Produces application/octet-stream application/json
PEP 8 search
NameTypeData typeDescription
collection_namepathstringThe name of the collection
filterquerystringThe filter to limit the returned results.
limitqueryintegerThe limit of results to return
offsetqueryintegerThe offset of results to return
parametersquerydictionaryFull query string parameters payload in JSON format.
sortquerystringThe sort order for the returned results.
from falconpy import CustomStorage
falcon = CustomStorage(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.search(collection_name="string",
filter="string",
limit=integer,
offset=integer,
sort="string")
print(response)

Get the bytes for the specified object

GET /customobjects/v1/collections/{collection_name}/objects/{object_key}
Scope Custom Storage: READ Consumes · Produces application/json application/octet-stream
PEP 8 get
NameTypeData typeDescription
collection_namepathstringThe name of the collection
object_keypathstringThe object key
from falconpy import CustomStorage
falcon = CustomStorage(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
with open("output_file", "wb") as save_file:
response = falcon.get(collection_name="string",
object_key="string",
stream=boolean)
save_file.write(response)

Put the specified new object at the given key or overwrite an existing object at the given key

PUT /customobjects/v1/collections/{collection_name}/objects/{object_key}
Scope Custom Storage: WRITE Consumes · Produces application/octet-stream application/json
PEP 8 upload
NameTypeData typeDescription
bodybodystringThe object to be uploaded in binary format.
collection_namepathstringThe name of the collection.
dry_runquerybooleanIf false, run the operation as normal. If true, validate that the request would succeed, but don’t execute it.
object_keypathstringThe object key.
parametersquerydictionaryFull query string parameters payload in JSON format.
schema_versionquerystringThe version of the collection schema.
from falconpy import CustomStorage
falcon = CustomStorage(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.upload(collection_name="string",
dry_run=boolean,
object_key="string",
schema_version="string")
print(response)

Delete the specified object

DELETE /customobjects/v1/collections/{collection_name}/objects/{object_key}
Scope Custom Storage: WRITE Consumes · Produces application/json
PEP 8 delete
NameTypeData typeDescription
collection_namepathstringThe name of the collection
dry_runquerybooleanIf false, run the operation as normal. If true, validate that the request would succeed, but don’t execute it.
object_keypathstringThe object key
parametersquerydictionaryFull query string parameters payload in JSON format.
from falconpy import CustomStorage
falcon = CustomStorage(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.delete(collection_name="string",
dry_run=boolean,
object_key="string")
print(response)

Get the metadata for the specified object

GET /customobjects/v1/collections/{collection_name}/objects/{object_key}/metadata
Scope Custom Storage: READ Consumes · Produces application/json
PEP 8 metadata
NameTypeData typeDescription
collection_namepathstringThe name of the collection
object_keypathstringThe object key
from falconpy import CustomStorage
falcon = CustomStorage(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.metadata(collection_name="string", object_key="string")
print(response)

Get the list of schemas for the requested collection in reverse version order (latest first).

GET /customobjects/v1/collections/{collection_name}/schemas
Scope Custom Storage: READ Consumes · Produces application/json
PEP 8 list_schemas
NameTypeData typeDescription
collection_namepathstringThe name of the collection.
endquerystringThe end key to end listing to.
limitqueryintegerThe limit of results to return.
parametersquerydictionaryFull query string parameters payload in JSON format.
startquerystringThe start key to start listing from.
from falconpy import CustomStorage
falcon = CustomStorage(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.list_schemas(collection_name="string",
end=["string"],
limit=integer,
start=["string"])
print(response)

Get the bytes of the specified schema of the requested collection.

GET /customobjects/v1/collections/{collection_name}/schemas/{schema_version}
Scope Custom Storage: READ Consumes · Produces application/json application/octet-stream
PEP 8 get_schema
NameTypeData typeDescription
collection_namepathstringThe name of the collection
schema_versionpathstringThe version of the collection schema or ‘latest’ for the latest version
from falconpy import CustomStorage
falcon = CustomStorage(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
with open("output_file", "wb") as save_file:
response = falcon.get_schema(collection_name="string",
schema_version="string",
stream=boolean)
save_file.write(response)

Get the metadata for the specified schema of the requested collection.

GET /customobjects/v1/collections/{collection_name}/schemas/{schema_version}/metadata
Scope Custom Storage: READ Consumes · Produces application/json
PEP 8 schema_metadata
NameTypeData typeDescription
collection_namepathstringThe name of the collection.
schema_versionpathstringThe version of the collection schema or ‘latest’ for the latest version.
from falconpy import CustomStorage
falcon = CustomStorage(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.schema_metadata(collection_name="string",
schema_version="string")
print(response)

List the object keys in the specified collection in alphabetical order

GET /customobjects/v1/collections/{collection_name}/{collection_version}/objects
Scope Custom Storage: READ Consumes · Produces application/json
PEP 8 list_by_version
NameTypeData typeDescription
collection_namepathstringThe name of the collection
collection_versionpathstringThe version of the collection
endquerystringThe end key to end listing to
limitqueryintegerThe limit of results to return
parametersquerydictionaryFull query string parameters payload in JSON format.
startquerystringThe start key to start listing from
from falconpy import CustomStorage
falcon = CustomStorage(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.list_by_version(collection_name="string",
collection_version="string",
end="string",
limit=integer,
start="string")
print(response)

Search for objects that match the specified filter criteria (returns metadata, not actual objects)

POST /customobjects/v1/collections/{collection_name}/{collection_version}/objects
Scope Custom Storage: READ Consumes · Produces application/octet-stream application/json
PEP 8 search_by_version
NameTypeData typeDescription
collection_namepathstringThe name of the collection
collection_versionpathstringThe version of the collection
filterquerystringThe filter to limit the returned results.
limitqueryintegerThe limit of results to return
offsetqueryintegerThe offset of results to return
parametersquerydictionaryFull query string parameters payload in JSON format.
sortquerystringThe sort order for the returned results.
from falconpy import CustomStorage
falcon = CustomStorage(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.search_by_version(collection_name="string",
collection_version="string",
filter="string",
limit=integer,
offset=integer,
sort="string")
print(response)

Get the bytes for the specified object

GET /customobjects/v1/collections/{collection_name}/{collection_version}/objects/{object_key}
Scope Custom Storage: READ Consumes · Produces application/json application/octet-stream
PEP 8 get_version
NameTypeData typeDescription
collection_namepathstringThe name of the collection
collection_versionpathstringThe version of the collection
object_keypathstringThe object key
from falconpy import CustomStorage
falcon = CustomStorage(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
with open("output_file", "wb") as save_file:
response = falcon.get_version(collection_name="string",
collection_version="string",
object_key="string",
stream=boolean)
save_file.write(response)

Put the specified new object at the given key or overwrite an existing object at the given key

PUT /customobjects/v1/collections/{collection_name}/{collection_version}/objects/{object_key}
Scope Custom Storage: WRITE Consumes · Produces application/octet-stream application/json
PEP 8 upload_version
NameTypeData typeDescription
bodybodystringThe object to be uploaded in binary format.
collection_namepathstringThe name of the collection.
collection_versionpathstringThe version of the collection.
dry_runquerybooleanIf false, run the operation as normal. If true, validate that the request would succeed, but don’t execute it.
object_keypathstringThe object key.
parametersquerydictionaryFull query string parameters payload in JSON format.
schema_versionquerystringThe version of the collection schema.
from falconpy import CustomStorage
falcon = CustomStorage(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.upload_version(collection_name="string",
collection_version="string",
dry_run=boolean,
object_key="string")
print(response)

Delete the specified versioned object

DELETE /customobjects/v1/collections/{collection_name}/{collection_version}/objects/{object_key}
Scope Custom Storage: WRITE Consumes · Produces application/json
PEP 8 delete_version
NameTypeData typeDescription
collection_namepathstringThe name of the collection
collection_versionpathstringThe version of the collection
dry_runquerybooleanIf false, run the operation as normal. If true, validate that the request would succeed, but don’t execute it.
object_keypathstringThe object key
parametersquerydictionaryFull query string parameters payload in JSON format.
from falconpy import CustomStorage
falcon = CustomStorage(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.delete_version(collection_name="string",
collection_version="string",
dry_run=boolean,
object_key="string")
print(response)

Get the metadata for the specified object

GET /customobjects/v1/collections/{collection_name}/{collection_version}/objects/{object_key}/metadata
Scope Custom Storage: READ Consumes · Produces application/json
PEP 8 version_metadata
NameTypeData typeDescription
collection_namepathstringThe name of the collection
collection_versionpathstringThe version of the collection
object_keypathstringThe object key
from falconpy import CustomStorage
falcon = CustomStorage(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.version_metadata(collection_name="string",
collection_version="string",
object_key="string")
print(response)